/*
 * INEM-Suxx, Una pequea aplicacin de altas, bajas y modificaciones.
 * Copyright (C) 1999 Paco Brufal <pbrufal@ctv.es>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "proyecto.h"

int main(int argc, char *argv[]) {
    int old_option=(-1),new_option=0;

    cargar("ofertas.db");
    cargar("demandas.db");
    cargar("emptit.db");
 
    if(argv[1]!=NULL) {
        if(!strcmp("-o",argv[1])) {
            gen_html("ofertas");
            exit(0);
        }
        if(!strcmp("-d",argv[1])) {
            gen_html("demandas");
            exit(0);
        }
        if(!strcmp("-h",argv[1])) {
            ayuda();
            exit(0);
        }
        if(!strcmp("-c",argv[1])) {
            candi();
            exit(0);
        }
    }
 
    if (!initTest (&win)) exit(1);
 
    wattrset(win, A_REVERSE);
    erase();
    display_menu(old_option,new_option);

    while(1) {
        noecho(); 
        keypad(stdscr,TRUE);
        raw();
        key = getch();
        switch(key) {
          case 10:
          case 13:
          case KEY_ENTER:
            erase();
            refresh();
            erase();
            (*command[new_option].function)();
            display_menu(old_option,new_option);
            break;
          case KEY_UP:
            new_option = (new_option == 0) ? new_option : new_option-1;
            display_menu(old_option,new_option);
            break;
          case KEY_DOWN:
            new_option = (new_option == MAX_OPTIONS-1) ? new_option : new_option+1;
            display_menu(old_option,new_option);
            break;
          case 'Q':
          case 'q': salir(); break;
          default: break;
         }
     if (quit == TRUE) break;
     }
    delwin(win);
    endwin();
    exit(0); 
}

int initTest (WINDOW **win) {
    initscr();
    width  = 60;
    height = 13;                
    *win = newwin(height, width, (LINES-height)/2, (COLS-width)/2);
    if(*win == NULL) {
        endwin();
        return 0;
    }
    return 1;
}

void display_menu(int old_option,int new_option) {
    register size_t i;

    attrset(A_REVERSE);
    mvprintw(1,12,"INEM-Suxx %s. Proyecto Fin de Curso. Paco Brufal, 1999",version);
    attrset(A_NORMAL);
    for (i=0;i<MAX_OPTIONS;i++)
        mvaddstr(6+i,30,command[i].text);
    if (old_option != (-1))
        mvaddstr(6+old_option,30,command[old_option].text);
    attrset(A_UNDERLINE);
    mvaddstr(6+new_option,30,command[new_option].text);
    attrset(A_REVERSE);
    mvaddstr(3,30," Seleccione accin: ");
    mvaddstr(23,12," Enter: Aceptar                           Q/q: Salir ");
    refresh();
}

int dialogbox(char* message) {
  char answer;

  dialog=newwin(LINES/6,COLS/3,LINES/3,COLS/3);
  wattron(dialog,COLOR_PAIR(4));
  mvwaddstr(dialog,1,(COLS/6)-(strlen(message)/2),message);
  box(dialog,0,0);
  wnoutrefresh(dialog);
  refresh();
  answer=getch();
  while(!((answer=='s')||(answer=='n'))) {
    wattron(dialog,A_BLINK);
    mvwaddstr(dialog,2,5,"Responda bien: S/N");
    wattroff(dialog,A_BLINK);
    wnoutrefresh(dialog);
    refresh();
    answer=getch();
  }
  if(answer=='n') return(0);
  else return(1);
}

void salir(void) {
    quit=TRUE;

    if(cambios==1) {
        if(dialogbox("Guardar cambios? (S/N)")) {
            salvar();
            return;
        }
        else return;
    }
}

void alta_oferta(void) {
    register int i;
    char resp,empleo[3],personas[3],datadia[2],datames[2],dataanyo[4];
    int bien=0;
    
    WINDOW *alta_ofer;
    alta_ofer=newwin(LINES,COLS,0,0);
    
    for(i=0;i<TAM;i++) if(!*ofertas[i].empresa) break;
    erase();
    if(i==TAM) {
        mvwaddstr(alta_ofer,10,10," No queda espacio en la lista.");
        mvwaddstr(alta_ofer,12,10,"Pulse una tecla para continuar.");
        wrefresh(alta_ofer);
        wgetch(alta_ofer);
        delwin(alta_ofer);
        return;
    }
    if(modifica==1) i=posicion;

    wrefresh(alta_ofer);
    wattrset(alta_ofer,A_REVERSE);
    mvwaddstr(alta_ofer,2,5,"Altas de ofertas");
    wattrset(alta_ofer,A_NORMAL);
    mvwprintw(alta_ofer,2,30,"Posicin: %d  Libres: %d",i, TAM-i);
    mvwaddstr(alta_ofer,5,5,"1.- Empresa      :");
    mvwaddstr(alta_ofer,7,5,"2.- CIF          :");
    mvwaddstr(alta_ofer,9,5,"3.- Fecha oferta :");
    mvwaddstr(alta_ofer,11,5,"4.- Tipo empleo  :");
    mvwaddstr(alta_ofer,13,5,"5.- N personas  :");
    mvwaddstr(alta_ofer,15,5,"6.- Sexo         :");
    wattrset(alta_ofer,A_REVERSE);
    mvwaddstr(alta_ofer,5,24,"                              ");
    mvwaddstr(alta_ofer,7,24,"         ");
    mvwaddstr(alta_ofer,9,24,"          ");
    mvwaddstr(alta_ofer,9,26,"/");
    mvwaddstr(alta_ofer,9,29,"/");
    mvwaddstr(alta_ofer,11,24,"  ");
    mvwaddstr(alta_ofer,13,24,"  ");
    mvwaddstr(alta_ofer,15,24," ");
    wattrset(alta_ofer,A_NORMAL);
    wrefresh(alta_ofer);
    for(;;) {
        echo();
        mvwaddstr(alta_ofer,19,5,"                         ");
        wattrset(alta_ofer,A_REVERSE);
        mvwaddstr(alta_ofer,23,2,"                                                                     ");
        mvwaddstr(alta_ofer,5,24,"                              ");
        mvwaddstr(alta_ofer,23,2,"Nombre de la empresa. 30 caracteres mximo");
        mvwgetnstr(alta_ofer,5,24,ofertas[i].empresa,30);
        for(;;) {
            mvwaddstr(alta_ofer,7,24,"         ");
            mvwaddstr(alta_ofer,23,2,"Numero CIF de la empresa. 8 numeros y 1 letra mayscula");
            mvwgetnstr(alta_ofer,7,24,ofertas[i].cif,9);
            if(compruebacif(ofertas[i].cif)) break;
        }
        for(;;) {
            mvwaddstr(alta_ofer,23,2,"Dia del mes.                                              ");
            if(error==1) mvwaddstr(alta_ofer,9,24,"  ");
            mvwgetnstr(alta_ofer,9,24,datadia,2);
            ofertas[i].dia_ofer=strtol(datadia,NULL,10); dia=ofertas[i].dia_ofer;
            if(compruebadia(ofertas[i].dia_ofer)) {
                mvwaddstr(alta_ofer,23,2,"Mes del ao.                          ");
                if(error==1) mvwaddstr(alta_ofer,9,27,"  ");
                mvwgetnstr(alta_ofer,9,27,datames,2);
                ofertas[i].mes_ofer=strtol(datames,NULL,10);
                if(compruebames(ofertas[i].mes_ofer)) {
                    mvwaddstr(alta_ofer,23,2,"Ao en formato de 4 cifras.");
                    if(error==1) mvwaddstr(alta_ofer,9,30,"    ");
                    mvwgetnstr(alta_ofer,9,30,dataanyo,4);
                    ofertas[i].anyo_ofer=strtol(dataanyo,NULL,10);
                    if(compruebaanyo(ofertas[i].anyo_ofer)) break;
                }
            }
            error=0;
        }
        for(;;) {
            mvwaddstr(alta_ofer,23,2,"Clase de empleo. Entre 1 y 30.              ");
            mvwaddstr(alta_ofer,11,24,"  ");
            mvwgetnstr(alta_ofer,11,24,empleo,2);
            ofertas[i].tipo_emp = strtol(empleo,NULL,10);
            wattrset(alta_ofer,A_UNDERLINE);
            mvwprintw(alta_ofer,11,28,"%s",emp_tit[ofertas[i].tipo_emp].empleo);
            wattrset(alta_ofer,A_REVERSE);
            if(compruebaempleo(ofertas[i].tipo_emp)) break;
        }
        for(;;) {
            mvwaddstr(alta_ofer,23,2,"Numero de personas solicitadas.          ");
            mvwaddstr(alta_ofer,13,24,"  ");
            mvwgetnstr(alta_ofer,13,24,personas,2);
            ofertas[i].num_per= strtol(personas,'\0',10);
            if(compruebapers(ofertas[i].num_per)) break;
        }
        for(;;) {
            mvwaddstr(alta_ofer,23,2,"Sexo de la(s) persona(s) solicitadas. M(ujer)/H(ombre).");
            mvwaddstr(alta_ofer,15,24," ");
            mvwgetnstr(alta_ofer,15,24,&ofertas[i].sexo,1);
            if(compruebasexo(&ofertas[i].sexo)) break;
        }
        wattrset(alta_ofer,A_NORMAL);
        mvwaddstr(alta_ofer,19,5,"Son los datos correctos?");
        wrefresh(alta_ofer);
        noecho();
        resp=wgetch(alta_ofer);
        switch(resp) {
            case 's':
            case 'S':
                bien=1;
                cambios=1;
                break;
            default: break;
        }
        if(bien==1) break;
    }
    delwin(alta_ofer);
}

void alta_dem(void) {
    register int e;
    int bien=0;
    char resp,edad[3],empleo[3],titul[3],datadia[2],datames[2],dataanyo[4];
    
    WINDOW *alta_demanda;
    alta_demanda=newwin(LINES,COLS,0,0);

    for(e=0;e<TAM;e++) if(!*demandas[e].nombre) break;
    erase();
    if(e==TAM) {
        mvwaddstr(alta_demanda,10,10," No queda espacio en la lista.");
        mvwaddstr(alta_demanda,12,10,"Pulse una tecla para continuar.");
        wrefresh(alta_demanda);
        wgetch(alta_demanda);
        delwin(alta_demanda);
        return;
    }
    if(modifica==1) e=posicion;    
    wrefresh(alta_demanda);
    mvwaddstr(alta_demanda,2,5,"Altas de demandas");
    mvwprintw(alta_demanda,2,30,"Posicin: %d  Libres: %d",e, TAM-e);
    mvwaddstr(alta_demanda,5,5,"Nombre     :");
    mvwaddstr(alta_demanda,5,60,"DNI  :");
    mvwaddstr(alta_demanda,7,60,"Edad :");
    mvwaddstr(alta_demanda,9,60,"Sexo :");
    mvwaddstr(alta_demanda,7,5,"Domicilio  :");
    mvwaddstr(alta_demanda,9,5,"Localidad  :");
    mvwaddstr(alta_demanda,11,5,"Provincia  :");
    mvwaddstr(alta_demanda,13,5,"Empleos    :");
    mvwaddstr(alta_demanda,15,5,"Situacin Laboral :");
    mvwaddstr(alta_demanda,17,5,"Titulacin        :");
    mvwaddstr(alta_demanda,19,5,"Fecha Demanda     :");
    wattrset(alta_demanda,A_REVERSE);
    mvwaddstr(alta_demanda,5,18,"                              ");
    mvwaddstr(alta_demanda,5,67,"        ");
    mvwaddstr(alta_demanda,7,67,"  ");
    mvwaddstr(alta_demanda,9,67," ");
    mvwaddstr(alta_demanda,7,18,"                              ");
    mvwaddstr(alta_demanda,9,18,"                    ");
    mvwaddstr(alta_demanda,11,18,"                    ");
    mvwaddstr(alta_demanda,13,18,"  ");
    mvwaddstr(alta_demanda,13,22,"  ");
    mvwaddstr(alta_demanda,13,26,"  ");
    mvwaddstr(alta_demanda,15,25," ");
    mvwaddstr(alta_demanda,17,25,"  ");
    mvwaddstr(alta_demanda,17,28,"  ");
    mvwaddstr(alta_demanda,17,31,"  ");
    mvwaddstr(alta_demanda,19,25,"  /  /    ");
    wattrset(alta_demanda,A_NORMAL);
    wrefresh(alta_demanda);
    for(;;) { 
        echo();
        wattrset(alta_demanda,A_REVERSE);
        mvwaddstr(alta_demanda,23,2,"Nombre. 30 caracteres mximo                              ");
        mvwgetnstr(alta_demanda,5,18,demandas[e].nombre,30);
        for(;;) {
            mvwaddstr(alta_demanda,5,67,"        ");
            mvwaddstr(alta_demanda,23,2,"DNI. 8 nmeros               ");
            mvwgetnstr(alta_demanda,5,67,demandas[e].dni,8);
            if(compruebadni(demandas[e].dni)) break;
        }
        mvwaddstr(alta_demanda,23,2,"Domicilio. 30 caracteres mximo");
        mvwgetnstr(alta_demanda,7,18,demandas[e].domicilio,30);
        for(;;) {
            mvwaddstr(alta_demanda,7,67,"  ");
            mvwaddstr(alta_demanda,23,2,"Edad.                             ");
            mvwgetnstr(alta_demanda,7,67,edad,2);
            demandas[e].edad=strtol(edad,NULL,10);
            if(compruebapers(demandas[e].edad)) break;
        }
        mvwaddstr(alta_demanda,23,2,"Localidad. 20 caracteres mximo");
        mvwgetnstr(alta_demanda,9,18,demandas[e].localidad,20);
        for(;;) {
            mvwaddstr(alta_demanda,9,67," ");
            mvwaddstr(alta_demanda,23,2,"Sexo. H o M.                         ");
            mvwgetnstr(alta_demanda,9,67,&demandas[e].sexo,1);
            if(compruebasexo(&demandas[e].sexo)) break;
        }
        mvwaddstr(alta_demanda,23,2,"Provincia. 20 caracteres mximo");
        mvwgetnstr(alta_demanda,11,18,demandas[e].provincia,30);
        for(;;) {
            mvwaddstr(alta_demanda,13,18,"  ");
            mvwaddstr(alta_demanda,23,2,"Empleo que se solicita.               ");
            mvwgetnstr(alta_demanda,13,18,empleo,2);
            demandas[e].tipo_empleo1=strtol(empleo,NULL,10);
            wattrset(alta_demanda,A_UNDERLINE);
            if(compruebaempleo(demandas[e].tipo_empleo1)) mvwprintw(alta_demanda,13,30,"%s",
                emp_tit[demandas[e].tipo_empleo1].empleo);
            wattrset(alta_demanda,A_REVERSE);
            if(compruebaempleo(demandas[e].tipo_empleo1)) {
                mvwaddstr(alta_demanda,13,22,"  ");
                mvwgetnstr(alta_demanda,13,22,empleo,2);
                demandas[e].tipo_empleo2=strtol(empleo,NULL,10);
                wattrset(alta_demanda,A_UNDERLINE);
                if(compruebaempleo(demandas[e].tipo_empleo2)) mvwprintw(alta_demanda,13,47,"%s",
                    emp_tit[demandas[e].tipo_empleo2].empleo);
                wattrset(alta_demanda,A_REVERSE);
                if(compruebaempleo(demandas[e].tipo_empleo2)) {
                    mvwaddstr(alta_demanda,13,26,"  ");
                    mvwgetnstr(alta_demanda,13,26,empleo,2);
                    demandas[e].tipo_empleo3=strtol(empleo,NULL,10);
                    wattrset(alta_demanda,A_UNDERLINE);
                    if(compruebaempleo(demandas[e].tipo_empleo3)) mvwprintw(alta_demanda,13,62,
                        "%s",emp_tit[demandas[e].tipo_empleo3].empleo);
                    wattrset(alta_demanda,A_REVERSE);
                    if(compruebaempleo(demandas[e].tipo_empleo3)) break;
                }
            }
        }
        for(;;) {
            mvwaddstr(alta_demanda,15,25," ");
            mvwaddstr(alta_demanda,23,2,"Situacin laboral actual. A o P.       ");
            mvwgetnstr(alta_demanda,15,25,&demandas[e].sit_lab,1);
            if(compruebasitu(&demandas[e].sit_lab)) break;
        }
        for(;;) {
            mvwaddstr(alta_demanda,17,25,"  ");
            mvwaddstr(alta_demanda,23,2,"Titulacines.                      ");
            mvwgetnstr(alta_demanda,17,25,titul,2);
            demandas[e].titul1=strtol(titul,NULL,10);
            wattrset(alta_demanda,A_UNDERLINE);
            if(compruebaempleo(demandas[e].titul1)) mvwprintw(alta_demanda,17,40,"%s",
                emp_tit[demandas[e].titul1].titulacion);
            wattrset(alta_demanda,A_REVERSE);
            if(compruebaempleo(demandas[e].titul1)) {
                mvwaddstr(alta_demanda,17,28,"  ");
                mvwgetnstr(alta_demanda,17,28,titul,2);
                demandas[e].titul2=strtol(titul,NULL,10);
                wattrset(alta_demanda,A_UNDERLINE);
                if(compruebaempleo(demandas[e].titul2)) mvwprintw(alta_demanda,17,50,"%s",
                    emp_tit[demandas[e].titul2].titulacion);
                wattrset(alta_demanda,A_REVERSE);
                if(compruebaempleo(demandas[e].titul2)) {
                    mvwaddstr(alta_demanda,17,31,"  ");
                    mvwgetnstr(alta_demanda,17,31,titul,2);
                    demandas[e].titul3=strtol(titul,NULL,10);
                    wattrset(alta_demanda,A_UNDERLINE);
                    if(compruebaempleo(demandas[e].titul3)) mvwprintw(alta_demanda,17,60,"%s",
                        emp_tit[demandas[e].titul3].titulacion);
                    wattrset(alta_demanda,A_REVERSE);
                    if(compruebaempleo(demandas[e].titul3)) break;
                }
            }
        }
        for(;;) {
            if(error==1) mvwaddstr(alta_demanda,19,25,"  ");
            mvwaddstr(alta_demanda,23,2,"Dia del mes.                                     ");
            mvwgetnstr(alta_demanda,19,25,datadia,2);
            demandas[e].dia_dem=strtol(datadia,NULL,10); dia=demandas[e].dia_dem;
            if(compruebadia(demandas[e].dia_dem)) {
                if(error==1) mvwaddstr(alta_demanda,19,28,"  ");
                mvwaddstr(alta_demanda,23,2,"Mes del ao.                          ");
                mvwgetnstr(alta_demanda,19,28,datames,2);
                demandas[e].mes_dem=strtol(datames,NULL,10);
                if(compruebames(demandas[e].mes_dem)) {
                    if(error==1) mvwaddstr(alta_demanda,19,31,"  ");
                    mvwaddstr(alta_demanda,23,2,"Ao en formato de 4 cifras.");
                    mvwgetnstr(alta_demanda,19,31,dataanyo,4);
                    demandas[e].anyo_dem=strtol(dataanyo,NULL,10);
                    if(compruebaanyo(demandas[e].anyo_dem)) break;
                }
            }
            error=0;
        }
        wattrset(alta_demanda,A_NORMAL);
        mvwaddstr(alta_demanda,23,2,"                                                                  ");
        mvwaddstr(alta_demanda,22,5,"Son los datos correctos?");
        wrefresh(alta_demanda);
        noecho();
        resp=wgetch(alta_demanda);
        switch(resp) {
            case 's':
            case 'S':
                bien=1;
                cambios=1;
                break;
            default: break;
        }
        if(bien==1) break;
    }
    delwin(alta_demanda);    
}

int compruebadni (char *cad) {
    register int p;

    for(p=0;p<7;p++)
        if(!isdigit(cad[p])) return 0;
    return 1;
}

int compruebacif(char *cad) {

    if(isdigit(cad[0]) && isdigit(cad[1]) && isdigit(cad[2]) && isdigit(cad[3]) && isdigit(cad[4])
        && isdigit(cad[5]) && isdigit(cad[6]) && isdigit(cad[7]) && isalpha(cad[8]) 
        && isupper(cad[8]))
        return 1;
    return 0;
}

int compruebadia(int dia) {

    if(dia>0 && dia<32) return 1;
    else { error=1 ; return 0; }
}

int compruebames(int mes) {

    if(mes==2 && dia>28) return 0;
    if(mes>0 && mes<13) return 1;
    else { error=1 ; return 0; }
}
int compruebaanyo(int anyo) {

    if(anyo>0 && anyo<10000) return 1;
    else { error=1 ; return 0; }
}
  
int compruebaempleo(int cant) {

    if(cant<0 || cant>EMP || cant>ult_emp || cant>ult_tit) return 0;
    else return 1;
}
int compruebapers(int pers) {

    if(pers<1 || pers>100) return 0;
    return 1;
}

int compruebasexo(char *cad) {

    if(!strcmp("H",&cad[0]) || !strcmp("M",&cad[0]) || !strcmp("h",&cad[0])
        || !strcmp("m",&cad[0])) return 1;
    return 0;
}

int compruebasitu(char *cad) {

    if(!strcmp("P",&cad[0]) || !strcmp("A",&cad[0]) || !strcmp("p",&cad[0])
        || !strcmp("a",&cad[0])) return 1;
    return 0;
}

void cargar(char *fichero) {
    FILE *pf;
    register int reg;

    if((pf=fopen(fichero,"rb"))==NULL) {
        if((pf=fopen(fichero,"ab"))==NULL) {
            printf("Error en la apertura del fichero.\n");
            exit(1);
        }
    }
    if(!strcmp("ofertas.db",fichero)) {
            for(reg=0;reg<TAM;reg++) {
                if(fread(&ofertas[reg],sizeof(struct reg_ofertas),1,pf)!=1) {
                    if(feof(pf)) break;
                }
            }
    }
    if(!strcmp("demandas.db",fichero)) {
            for(reg=0;reg<TAM;reg++) {
                if(fread(&demandas[reg],sizeof(struct reg_demandas),1,pf)!=1) {
                    if(feof(pf)) break;
                }
            }
    }
    if(!strcmp("emptit.db",fichero)) {
            for(reg=0;reg<EMP;reg++) {
                if(fread(&emp_tit[reg],sizeof(struct reg_emp_tit),1,pf)!=1) {
                    if(feof(pf)) break;
                }
                ult_emp=reg;
                ult_tit=reg;
            }
    }
    fclose(pf);
}

void salvar(void) {
    FILE *pf;
    register int i;

    if((pf=fopen("ofertas.db","wb"))==NULL) {
        mvwaddstr(win,10,10,"Error al abrir el archivo.");
    }
    for(i=0;i<TAM;i++)
        if(*ofertas[i].empresa)
            if(fwrite(&ofertas[i],sizeof(struct reg_ofertas),1,pf)!=1)
                mvwaddstr(win,10,10,"Error de escritura.");
    fclose(pf);
    if((pf=fopen("demandas.db","wb"))==NULL) {
        mvwaddstr(win,10,10,"Error al abrir el archivo.");
    }
    for(i=0;i<TAM;i++)
        if(*demandas[i].nombre)
            if(fwrite(&demandas[i],sizeof(struct reg_demandas),1,pf)!=1)
                mvwaddstr(win,10,10,"Error de escritura.\n");
    fclose(pf);
    if((pf=fopen("emptit.db","wb"))==NULL) {
        mvwaddstr(win,10,10,"Error al abrir el archivo.");
    }
    for(i=0;i<EMP;i++)
        if((*emp_tit[i].empleo && *emp_tit[i].titulacion) ||
            (!*emp_tit[i].empleo && *emp_tit[i].titulacion) ||
            (*emp_tit[i].empleo && !*emp_tit[i].titulacion))
            if(fwrite(&emp_tit[i],sizeof(struct reg_emp_tit),1,pf)!=1)
                mvwaddstr(win,10,10,"Error de escritura.\n");
    fclose(pf);
    cambios=0;
}

void html(void) {
    char op;
    WINDOW *htmlwin;

    htmlwin=newwin(LINES,COLS,0,0);
    erase();
    mvwaddstr(htmlwin,2,5,"Generacin de HTML");
    mvwaddstr(htmlwin,7,5,"Pulse O para generar la pgina de OFERTAS de empleo.");
    mvwaddstr(htmlwin,9,5,"Pulse D para generar la pgina de DEMANDAS de empleo.");
    wattrset(htmlwin,A_REVERSE);
    mvwaddstr(htmlwin,23,2,"Generacin de pginas HTML listas para poner en Internet.");
    wattrset(htmlwin,A_NORMAL);
    op=wgetch(htmlwin);
    switch(op) {
        case 'D':
        case 'd':
            gen_html("demandas"); break;
        case 'O':
        case 'o':
            gen_html("ofertas"); break;
    }
    delwin(htmlwin);
}

void gen_html(char *tipo) {
    register int f;
    FILE *html;

    if(!strncmp("ofertas",tipo,7)) {
        if((html=fopen("ofertas.html","wt"))==NULL) {
            printf("Error al abrir el archivo.\n");
            return;
        }
        fprintf(html,"<!doctype html public \"-//w3c//dtd html 4.0 transitional//en\">
<html>
<head>
   <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
   <meta name=\"Author\" content=\"Paco Brufal\">
   <meta name=\"GENERATOR\" content=\"INEM-Suxx %s\">
   <title>Ofertas de trabajo</title>
</head>

<body>
<center>
<h2>Ofertas de trabajo</h2>
</center>
<hr WIDTH=\"100%%\">",version);
    for(f=0;f<TAM;f++) {
        if(*ofertas[f].empresa)
            if(ofertas[f].num_per>0) {
                fprintf(html,"<li>
%d: Precisamos de %d persona(s) para el puesto de %s.
Enviar curr&iacute;culum a %s. %d/%d/%d.</li><br><hr WIDTH=\"100%%\">",f,ofertas[f].num_per,
emp_tit[ofertas[f].tipo_emp].empleo,ofertas[f].empresa,ofertas[f].dia_ofer,ofertas[f].mes_ofer,
ofertas[f].anyo_ofer);
        }
    }
    fprintf(html,"<br><font size=-1>INEM-Suxx %s</font>
<br><font size=-1><a href=\"mailto:pbrufal@ctv.es\">pbrufal@ctv.es</a></font>
</body>
</html>",version);
    fclose(html);
  }

  if(!strncmp("demandas",tipo,7)) {
        if((html=fopen("demandas.html","wt"))==NULL) {
            printf("Error al abrir el archivo.\n");
            return;
        }
        fprintf(html,"<!doctype html public \"-//w3c//dtd html 4.0 transitional//en\">
<html>
<head>
   <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
   <meta name=\"Author\" content=\"Paco Brufal\">
   <meta name=\"GENERATOR\" content=\"INEM-Suxx %s\">
   <title>Demandas de trabajo</title>
</head>

<body>
<center>
<h2>Demandas de trabajo</h2>
</center>
<hr WIDTH=\"100%%\">",version);
    for(f=0;f<TAM;f++) {
        if(*demandas[f].nombre) {
            if(!strcmp(&demandas[f].sit_lab,"p") || !strcmp(&demandas[f].sit_lab,"P")) {
                fprintf(html,"<li>
%d: %s.<br>
Clase de trabajos solicitados: %s, %s, %s<br>
Titulaciones: %s %s %s. %d/%d/%d.</li><br><hr WIDTH=\"100%%\">",f,demandas[f].nombre,
emp_tit[demandas[f].tipo_empleo1].empleo,emp_tit[demandas[f].tipo_empleo2].empleo,
emp_tit[demandas[f].tipo_empleo3].empleo,emp_tit[demandas[f].titul1].titulacion, 
emp_tit[demandas[f].titul2].titulacion,emp_tit[demandas[f].titul3].titulacion,
demandas[f].dia_dem,demandas[f].mes_dem,demandas[f].anyo_dem);
            }
        }
    }
    fprintf(html,"<br><font size=-1>INEM-Suxx %s</font>
<br><font size=-1><a href=\"mailto:pbrufal@ctv.es\">pbrufal@ctv.es</a></font>
</body>
</html>",version);
    fclose(html);
  } 

}

void mas_empleo(void) {
    register int m;
    char resp;
    int salir=0;
    WINDOW *empleo;

    empleo=newwin(LINES,COLS,0,0);
    for(m=0;m<EMP;m++) if(!*emp_tit[m].empleo) break;
    erase();
    if(m==TAM) {
        mvwaddstr(empleo,10,10," No queda espacio en la lista.");
        mvwaddstr(empleo,12,10,"Pulse una tecla para continuar.");
        wrefresh(empleo);
        wgetch(empleo);
        delwin(empleo);
        return;
    }
    if(modifica==1) m=posicion;
    wattrset(empleo,A_NORMAL);
    mvwaddstr(empleo,2,5,"Aadir / Modificar empleos");
    mvwprintw(empleo,4,5,"Posicin: %d\tEmpleo: %s",m,emp_tit[m].empleo);
    mvwaddstr(empleo,6,5,"Empleo :");
    for(;;) {
        wattrset(empleo,A_NORMAL);
        mvwaddstr(empleo,22,2,"                          ");
        wattrset(empleo,A_REVERSE);
        mvwaddstr(empleo,6,14,"                    ");
        echo();
        mvwgetnstr(empleo,6,14,emp_tit[m].empleo,20);
        wattrset(empleo,A_NORMAL);
        noecho();
        mvwaddstr(empleo,22,2,"Son los datos correctos?");
        resp=wgetch(empleo);
        switch(resp) {
            case 's':
            case 'S': salir=1; cambios=1; ult_emp++; break;
            default: break;
        }
    if(salir==1) break;
    }
    delwin(empleo);
}

void mas_titul(void) {
    register int m;
    char resp;
    int salir=0;
    WINDOW *titul;

    titul=newwin(LINES,COLS,0,0);
    for(m=0;m<EMP;m++) if(!*emp_tit[m].titulacion) break;
    erase();
    if(m==TAM) {
        mvwaddstr(titul,10,10," No queda espacio en la lista.");
        mvwaddstr(titul,12,10,"Pulse una tecla para continuar.");
        wrefresh(titul);
        wgetch(titul);
        delwin(titul);
        return;
    }
    if(modifica==1) m=posicion;
    wattrset(titul,A_NORMAL);
    mvwaddstr(titul,2,5,"Aadir / Modificar titulaciones");
    mvwprintw(titul,4,5,"Posicin: %d\tTitulacin: %s",m,emp_tit[m].titulacion);
    mvwaddstr(titul,6,5,"Titulacin :");
    for(;;) {
        wattrset(titul,A_NORMAL);
        mvwaddstr(titul,22,2,"                          ");
        wattrset(titul,A_REVERSE);
        mvwaddstr(titul,6,18,"                ");
        echo();
        strcpy(emp_tit[m].titulacion,"\0");
        mvwgetnstr(titul,6,18,emp_tit[m].titulacion,15);
        wattrset(titul,A_NORMAL);
        noecho();
        mvwaddstr(titul,22,2,"Son los datos correctos?");
        resp=wgetch(titul);
        switch(resp) {
            case 's':
            case 'S': salir=1; cambios=1; ult_tit++; break;
            default: break;
        }
    if(salir==1) break;
    }
    delwin(titul);
}

void modificar(void) {
    char pulsa,lugar[3];
    int modpos;
    WINDOW *modwin;

    modwin=newwin(LINES,COLS,0,0);
    erase();
    noecho();
    mvwaddstr(modwin,2,5,"Modificar datos");
    mvwaddstr(modwin,6,5,"Pulse O para modificar las OFERTAS");
    mvwaddstr(modwin,8,5,"Pulse D para modificar las DEMANDAS");
    mvwaddstr(modwin,10,5,"Pulse T para modificar las TITULACIONES");
    mvwaddstr(modwin,12,5,"Pulse E para modificar los EMPLEOS");
    pulsa=wgetch(modwin);
    echo();
    switch(pulsa) {
        case 'o':
        case 'O': 
            mvwaddstr(modwin,17,5,"Escriba la posicin a modificar: ");
            mvwgetnstr(modwin,17,40,lugar,2);
            modpos=strtol(lugar,NULL,10);
            modifica=1;
            posicion=modpos;
            alta_oferta();
            modifica=0;
            break;
        case 'd':
        case 'D':
            mvwaddstr(modwin,17,5,"Escriba la posicin a modificar: ");
            mvwgetnstr(modwin,17,40,lugar,2);
            modpos=strtol(lugar,NULL,10);
            modifica=1;
            posicion=modpos;
            alta_dem();
            modifica=0;
            break;
        case 't':
        case 'T':
            mvwaddstr(modwin,17,5,"Escriba la posicin a modificar: ");
            mvwgetnstr(modwin,17,40,lugar,2);
            modpos=strtol(lugar,NULL,10);
            modifica=1;
            posicion=modpos;
            mas_titul();
            modifica=0;
            break;
        case 'e':
        case 'E':
            mvwaddstr(modwin,17,5,"Escriba la posicin a modificar: ");
            mvwgetnstr(modwin,17,40,lugar,2);
            modpos=strtol(lugar,NULL,10);
            modifica=1;
            posicion=modpos;
            mas_empleo();
            modifica=0;
            break;
    }
    delwin(modwin);
}

void elimina(void) {
    char pulsa,posi[2],opcion;
    register int elipos;
    WINDOW *eliwin;

    eliwin=newwin(LINES,COLS,0,0);
    erase();
    noecho();
    mvwaddstr(eliwin,2,5,"Eliminar Entradas");
    mvwaddstr(eliwin,6,5,"Pulse O para eliminar una OFERTA");
    mvwaddstr(eliwin,7,5,"Pulse D para eliminar una DEMANDA");
    mvwaddstr(eliwin,8,5,"Pulse T para eliminar una TITULACION");
    mvwaddstr(eliwin,9,5,"Pulse E para eliminar un EMPLEO");
    pulsa=wgetch(eliwin);
    echo();
    switch(pulsa) {
        case 'o':
        case 'O':
            mvwaddstr(eliwin,11,5,"Introduzca la posicin a eliminar: ");
            mvwgetnstr(eliwin,11,40,posi,2);
            elipos=strtol(posi,NULL,10);
            mvwprintw(eliwin,13,5,"La posicin %d contiene estos datos:",elipos);
            mvwprintw(eliwin,15,5,"Empresa : %s",ofertas[elipos].empresa);
            mvwprintw(eliwin,15,50,"CIF      : %s",ofertas[elipos].cif);
            mvwprintw(eliwin,16,5,"Empleo  : %s",emp_tit[ofertas[elipos].tipo_emp].empleo);
            mvwprintw(eliwin,16,50,"Personas : %d",ofertas[elipos].num_per);
            mvwprintw(eliwin,17,5,"Fecha   : %d/%d/%d",ofertas[elipos].dia_ofer,
                ofertas[elipos].mes_ofer,ofertas[elipos].anyo_ofer);
            mvwprintw(eliwin,17,50,"Sexo     : %s",&ofertas[elipos].sexo);
            mvwaddstr(eliwin,20,5,"Realmente desea eliminar estos datos? (S/N)");
            noecho();
            opcion=wgetch(eliwin);
            switch(opcion) {
                case 's':
                case 'S':
                    *ofertas[elipos].empresa='\0';
                    cambios=1;
                    break;
                default: break;
            }
            break;
        case 'd':
        case 'D':
            mvwaddstr(eliwin,11,5,"Introduzca la posicin a eliminar: ");
            mvwgetnstr(eliwin,11,40,posi,2);
            elipos=strtol(posi,NULL,10);
            mvwprintw(eliwin,13,5,"La posicin %d contiene estos datos:",elipos);
            mvwprintw(eliwin,15,5,"Nombre     : %s",demandas[elipos].nombre);
            mvwprintw(eliwin,15,50,"DNI     : %s",demandas[elipos].dni);
            mvwprintw(eliwin,16,50,"Edad    : %d",demandas[elipos].edad);
            mvwprintw(eliwin,17,50,"Sexo    : %s",&demandas[elipos].sexo);
            mvwprintw(eliwin,17,5,"Domicilio  : %s",demandas[elipos].domicilio);
            mvwprintw(eliwin,16,5,"Localidad  : %s",demandas[elipos].localidad);
            mvwprintw(eliwin,18,5,"Provincia  : %s",demandas[elipos].provincia);
            mvwprintw(eliwin,19,50,"Empleos : %s %s %s",
                emp_tit[demandas[elipos].tipo_empleo1].empleo,
                emp_tit[demandas[elipos].tipo_empleo2].empleo,
                emp_tit[demandas[elipos].tipo_empleo3].empleo);
            mvwprintw(eliwin,19,5,"Titulacion : %s %s %s",
                emp_tit[demandas[elipos].titul1].titulacion,
                emp_tit[demandas[elipos].titul2].titulacion,
                emp_tit[demandas[elipos].titul3].titulacion);
            mvwprintw(eliwin,20,5,"Fecha      : %d/%d/%d",demandas[elipos].dia_dem,
                demandas[elipos].mes_dem,demandas[elipos].anyo_dem);
            mvwaddstr(eliwin,22,5,"Realmente desea eliminar estos datos? (S/N)");
            noecho();
            opcion=wgetch(eliwin);
            switch(opcion) {
                case 's':
                case 'S':
                    *demandas[elipos].nombre='\0';
                    cambios=1;
                    break;
                default: break;
            }
            break;
        case 't':
        case 'T':
            mvwaddstr(eliwin,11,5,"Introduzca la posicin a eliminar: ");
            mvwgetnstr(eliwin,11,40,posi,2);
            elipos=strtol(posi,NULL,10);
            mvwprintw(eliwin,13,5,"La posicin %d contiene estos datos:",elipos);
            mvwprintw(eliwin,15,5,"Titulacion: %s",emp_tit[elipos].titulacion);
            mvwaddstr(eliwin,19,5,"Realmente desea eliminar estos datos? (S/N)");
            noecho();
            opcion=wgetch(eliwin);
            switch(opcion) {
                case 's':
                case 'S':
                    *emp_tit[elipos].titulacion='\0';
                    cambios=1;
                    break;
                default: break;
            }
            break;
        case 'e':
        case 'E':
            mvwaddstr(eliwin,11,5,"Introduzca la posicin a eliminar: ");
            mvwgetnstr(eliwin,11,40,posi,2);
            elipos=strtol(posi,NULL,10);
            mvwprintw(eliwin,13,5,"La posicin %d contiene estos datos:",elipos);
            mvwprintw(eliwin,15,5,"Empleo: %s",emp_tit[elipos].empleo);
            mvwaddstr(eliwin,19,5,"Realmente desea eliminar estos datos? (S/N)");
            noecho();
            opcion=wgetch(eliwin);
            switch(opcion) {
                case 's':
                case 'S':
                    *emp_tit[elipos].empleo='\0';
                    cambios=1;
                    break;
                default: break;
            }
            break;
    }
    delwin(eliwin);
}

void candi(void) {
    register int c;
    register int h;
    FILE *candi;

    if((candi=fopen("candidatos.txt","at"))==NULL) return;
    time(&fecha);
    fecha=time(NULL);
    date_total=localtime(&fecha);
    fprintf(candi,"-*-*-*- Lista creada el %d/%d/%d a las %d:%d:%d -*-*-*-\n",
    date_total->tm_mday,date_total->tm_mon+1,date_total->tm_year+1900,
    date_total->tm_hour,date_total->tm_min,date_total->tm_sec);
    for(c=0;c<TAM;c++) {
        if(!*ofertas[c].empresa) break;
        if(ofertas[c].num_per>0) {
            fprintf(candi,"\nEmpresa: %s\n",ofertas[c].empresa);
            fprintf(candi,"Solicita: %d personas para el puesto de %s\n", ofertas[c].num_per,
                emp_tit[ofertas[c].tipo_emp].empleo);
            fprintf(candi,"Posibles candidatos:\n");
            for(h=0;h<TAM;h++) {
                if((ofertas[c].tipo_emp==demandas[h].tipo_empleo1 ||
                ofertas[c].tipo_emp==demandas[h].tipo_empleo2 ||
                ofertas[c].tipo_emp==demandas[h].tipo_empleo3)) {
                    fprintf(candi,"Registro: %d   Nombre: %s\n",h,demandas[h].nombre);
                    strcpy(&demandas[h].sit_lab,"a");
                }
            }
            if(ofertas[c].num_per>0) {
                ofertas[c].num_per--;
                cambios=1;
            }
        }
    }
    fprintf(candi,"\n");
    fclose(candi);
}

void ayuda(void) {
    printf("INEM-Suxx %s, (c) Paco Brufal 1999\n",version);
    printf("Este programa se distribuye bajo licencia GPL y SIN NINGUNA GARANTIA.\n");
    printf("Lea el fichero COPYING para obtener ms informacin.\n");
    printf("\nPrograma realizado para el Proyecto Fin de Curso de la asignatura\n");
    printf("Fundamentos de la Programacin.\n");
    printf("\nParmetros: -h  Este mensaje\n");
    printf("            -c  Generar lista de candidatos\n");
    printf("            -o  Generar pgina HTML de ofertas\n");
    printf("            -d  Generar pgina HTML de demandas\n");
}

/* FIN de INEM-Suxx */
